<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2012 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: Sylvia.class.php
| Version: 1.0.0
| Author: Yodix (www.on-deck.eu)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

class Sylvia {
	public $enabled = FALSE;
	public $settings = array();
	public $locale = array();
	
	public $px_version = FALSE;
	
	private $px_connect = FALSE;
	private $PointX;
	
	private $isset_error = FALSE;
	private $error_group = 0;
	
	private $isset_blockade = FALSE;
	private $blockade = array();
	private $html = "";
	
	private $isset_navi = FALSE;
	private $navi_content = "";
	
	const Version = "1.0.0";
	const AdminPages = "blockades,settings";
	const SitePages = "warnings,management";
	
	public function __construct () {
		if (dbcount("(inf_id)", DB_INFUSIONS, "inf_folder='sylvia'") == 1) {
			$ifLocale = $this->GetLocale();
			if (!$ifLocale) $super_error = TRUE;
			
			$ifSettings = $this->GetSettings();
			if (!$ifSettings) $super_error = TRUE;
			
			$this->ConnectPointX();
			
			return TRUE;
		} else {
			return FALSE;
		}
	}
	
	private function GetLocale () {
		global $settings;
		
		if (file_exists(INFUSIONS."sylvia/locale/".$settings['locale'].".php")) {
			include INFUSIONS."sylvia/locale/".$settings['locale'].".php";
			include INFUSIONS."sylvia/locale/".$settings['locale']."_errors.php";
		} else {
			include INFUSIONS."sylvia/locale/English.php";
			include INFUSIONS."sylvia/locale/English_errors.php";
		}
		
		if (isset($locale)) {
			$this->locale = $locale;
			
			return TRUE;
		} else {
			return FALSE;
		}
	}
	
	private function GetSettings () {
		$result = dbquery("SELECT settings_name, settings_value FROM ".DB_SETTINGS_INF." WHERE settings_inf='sylvia'");
		if (dbrows($result) != 0) {
			while ($data = dbarray($result)) {
				$this->settings[$data['settings_name']] = $data['settings_value'];
			}
			
			return TRUE;
		} else {
			return FALSE;
		}
	}
	
	private function ConnectPointX () {
		global $PointX;
		
		if (dbcount("(inf_id)", DB_INFUSIONS, "inf_folder='pointx'") == 1 && file_exists(INFUSIONS."pointx/system/PointX.class.php")) {
			if (str_replace(".", "", dbresult(dbquery("SELECT inf_version FROM ".DB_INFUSIONS." WHERE inf_folder='pointx'"), 0)) >= 202) {
				if ($this->settings['pointx_connected'] == 1) {
					$this->px_connect = TRUE;
					$this->PointX = $PointX;
					
					return TRUE;
				} else {
					$this->px_connect = FALSE;
					return FALSE;
				}
			} else {
				$this->px_version = TRUE;
				
				if ($this->settings['pointx_connected'] == 1) {
					$result = dbquery("UPDATE ".DB_SETTINGS_INF." SET settings_value='0' WHERE settings_name='pointx_connected' AND settings_inf='sylvia'");
					$this->px_connect = FALSE;
					return FALSE;
				} else {
					$this->px_connect = FALSE;
					return FALSE;
				}
			}
		} else {
			if ($this->settings['pointx_connected'] == 1) {
				$result = dbquery("UPDATE ".DB_SETTINGS_INF." SET settings_value='0' WHERE settings_name='pointx_connected' AND settings_inf='sylvia'");
				$this->px_connect = FALSE;
				return FALSE;
			} else {
				$this->px_connect = FALSE;
				return FALSE;
			}
		}
	}
	
	/* Funkcje Specjalne */
	
	public static function GenKey ($length = 5) {
		$chars = array("abcdefghijklmnpqrstuvwxyzABCDEFGHIJKLMNPQRSTUVWXYZ", "123456789");
		$count = array((strlen($chars[0]) - 1), (strlen($chars[1]) - 1));
		$key = "";
		for ($i = 0; $i < $length; $i++) {
			$type = mt_rand(0, 1);
			$key .= substr($chars[$type], mt_rand(0, $count[$type]), 1);
		}
		if (dbcount("(blockade_id)", DB_SYLVIA_BLOCKADES, "blockade_code='".$key."'") != 0) {
			return PointX::GenKey($length);
		} else {
			return $key;
		}
	}
	
	/* Funckje dla Ostrzee */
	
	public function GetWarnsStatus ($user_id, $only_show = FALSE) {
		if ($this->settings['warnings_type'] == 1) {
			return dbcount("(warn_id)", DB_SYLVIA_WARNS, "warn_user='".$user_id."'");
		} elseif ($this->settings['warnings_type'] == 2) {
			$percent_warns = 0;
			$percent_result = dbquery("SELECT warn_data FROM ".DB_SYLVIA_WARNS." WHERE warn_user='".$user_id."'");
			if (dbrows($percent_result) != 0) {
				while ($percent_data = dbarray($percent_result)) {
					$percent_warns = $percent_warns+$percent_data['warn_data'];
				}
				
				if ($percent_warns > 100) {
					return "100".($only_show ? "%" : "");
				} else {
					return $percent_warns.($only_show ? "%" : "");
				}
			} else {
				$percent_warns = 0;
				return $percent_warns.($only_show ? "%" : "");
			}
		}
	}
	
	/* Funkcje dla Blokad */
	
	public function InitBlockade ($key) {
		$result = dbquery("SELECT blockade_text, blockade_data FROM ".DB_SYLVIA_BLOCKADES." WHERE blockade_code='".$key."' AND blockade_active='1'");
		if (dbrows($result) != 0) {
			$data = dbarray($result);
			
			$this->blockade = array(
				"text" => $data['blockade_text'],
				"data" => $data['blockade_data']
			);
			$this->isset_blockade = TRUE;
		} else {
			$this->isset_blockade = FALSE;
			$this->blockade = array();
		}
	}
	
	public function InsertCode ($html) {
		if ($this->isset_blockade) {
			$this->html .= $html;
		} else {
			$this->html = "";
		}
	}
	
	public function LoadBlockade ($logic = FALSE) {
		global $userdata;
		
		if (iMEMBER && $this->isset_blockade) {
			$user_warns = $this->GetWarnsStatus($userdata['user_id']);
			if ($user_warns >= $this->blockade['data']) {
				return $logic ? TRUE : $this->blockade['text'];
			} else {
				return $logic ? FALSE : $this->html;
			}
		} else {
			return $logic ? FALSE :$this->html;
		}
	}
	
	public function ClearCode () {
		$this->html = "";
	}
	
	public function DestructBlockade () {
		$this->isset_blockade = FALSE;
		$this->blockade = array();
		$this->html = "";
		
		return TRUE;
	}
	
	/* Nawigacja */
	
	public function InitNavi () {
		if ($this->isset_navi == FALSE && empty($this->navi_content)) {
			$this->isset_navi = TRUE;
			
			return TRUE;
		} else {
			return FALSE;
		}
	}
	
	public function GenNavi ($html) {
		$this->navi_content .= $html;
	}
	
	public function RenderNavi () {
		if ($this->isset_navi == TRUE && !empty($this->navi_content)) {
			return $this->navi_content;
		} else {
			return FALSE;
		}
	}
	
	public function DestructNavi () {
		$this->isset_navi = FALSE;
		$this->navi_content = "";
		
		return TRUE;
	}
	
	/* Wiadomoci i Bdy */
	
	public function InitError ($group) {
		$array = array(1, 2, 3);
		
		if ($this->isset_error == FALSE && $this->error_group == 0 && in_array($group, $array)) {
			$this->isset_error = TRUE;
			$this->error_group = $group;
			
			return TRUE;
		} else {
			return FALSE;
		}
	}
	
	public function GetError ($message) {
		if ($this->isset_error == TRUE && $this->error_group == 1) {
			$group = "sylvia_error_01";
		} elseif ($this->isset_error == TRUE && $this->error_group == 2) {
			$group = "sylvia_error_02";
		} elseif ($this->isset_error == TRUE && $this->error_group == 3) {
			$group = "sylvia_error_03";
		} else {
			$group = "sylvia_error_00";
		}
		
		if (isset($this->locale[$group][$message])) {
			return $this->locale[$group][$message];
		} else {
			return $this->locale['sylvia_error_00']['locale_error'];
		}
	}
	
	public function DestructError () {
		$this->isset_error = FALSE;
		$this->error_group = 0;
		
		return TRUE;
	}
}
?>